package web.admin.cps.claim

import japgolly.scalajs.react._
import japgolly.scalajs.react.vdom.html_<^._
import japgolly.scalajs.react.extra._
import japgolly.scalajs.react.extra.router.RouterCtl
import web.base.all._
import relay.Container
import web.base.gql

import scala.scalajs.js

@gql("""
  fragment EventPaneDetail_claim on ClaimEvent {
      id rawId
    __typename
    when
    name
    ... on FnolCreated @scalajs(useNulls: true) {
      place {
        formattedAddress
      }
      expectedLossAmount
      lossDate
      description
      involvedParties
      policy {
        policy {
          details {
            policyId
            insuredLocation {
              formattedAddress
            }
          }
        }
      }
      uploads {
        id name url size contentType bucketKey source
      }
      when
    }
    ... on PolicySelected {
      policy { policy { details {
        policyId
        insuredLocation { formattedAddress }
      }}}
      when
    }
    ... on LossDateUpdated {
      lossDate
      prevLossDate
      when
    }
    ... on MessageSent {
      messageType isPrivate text
      documents {
        id name description url size contentType bucketKey source
      }
      when
    }
    ... on LossAdjustmentSubmitted {
      formInput {
        losses {
          id subsection comment amount acvAmount namedItem
        }
        lossDescription
        lossCauseSummary
        proximateLossCause
        coverageIssues
        lossPlace
        documents {
          id name description url size contentType bucketKey source
        }
      }
      when
    }
    ... on InitialReservePosted {
      reserve
      losses {
        id subsection comment amount acvAmount namedItem
      }
      when
    }
    ... on ReserveUpdated {
      reserve
      prevReserve
      losses {
        id subsection comment amount acvAmount namedItem
      }
      comment
      documents {
        id name description url size contentType bucketKey source
      }
      when
    }
    ... on ApprovedLossPosted {
      reserve
      prevReserve
      losses {
        id subsection comment amount acvAmount namedItem
      }
      prevLosses {
        id subsection comment amount acvAmount namedItem
      }
      approvedPayout
      prevApprovedPayout
      comment
      selectedDocuments {
        id name description url size contentType bucketKey source
      }
      when
    }
  }
""")
object EventPaneDetail {

  import relay.generated.EventPaneDetail_claim

  final case class Props(claim: EventPaneDetail_claim) {
    @inline def render: VdomElement = C(this)
  }

  private[this] final class Backend(val $ : BackendScope[Props, Unit]) {
    def render(p: Props): VdomElement = {
      <.div
    }
  }

  private[this] val C = Container
    .fragmentContainerBuilder(
      ScalaComponent
        .builder[Props]("EventPaneDetail")
        .renderBackend[Backend]
        .build)
    .addFrag(EventPaneDetail_claim)
    .build
}
